﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.ComponentModel;

namespace TreeViewAutoGenerateTemplates
{
	public partial class MainPage : UserControl
	{
		public MainPage()
		{
			InitializeComponent();

			treeView.ItemsSource = Enumerable.Range(1, 20).Select(i => new MyViewModel() { Title = "Title " + i }).ToList();
		}
	}

	public class MyViewModel : INotifyPropertyChanged
	{
		
		private String title;
		/// <summary>
		///     Gets or sets the title.
		/// </summary>
		public String Title
		{
			get
			{
				return this.title;
			}
			set
			{
				if (this.title != value)
				{
					this.title = value;
					OnPropertyChanged("Title");
				}
			}
		}
        

		/// <summary>
		///     Event for INotifyPropertyChanged.
		/// </summary>
		public event PropertyChangedEventHandler PropertyChanged;

		/// <summary>
		///     Raises the INotifyPropertyChanged event.
		/// </summary>
		/// <param name="propertyName">The property to be included in the INotifyPropertyChanged EventArgs.</param>
		protected virtual void OnPropertyChanged(String propertyName)
		{
			if (PropertyChanged != null)
			{
				PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
			}
		}
        
	}
}
